<?php

declare(strict_types=1);

namespace App\Modules\CardOrder\Policies;

use App\Modules\CardOrder\Models\CardState;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class CardStatePolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:CardState');
    }

    public function view(AuthUser $authUser, CardState $cardState): bool
    {
        return $authUser->can('View:CardState');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:CardState');
    }

    public function update(AuthUser $authUser, CardState $cardState): bool
    {
        return $authUser->can('Update:CardState');
    }

    public function delete(AuthUser $authUser, CardState $cardState): bool
    {
        return $authUser->can('Delete:CardState');
    }

    public function restore(AuthUser $authUser, CardState $cardState): bool
    {
        return $authUser->can('Restore:CardState');
    }

    public function forceDelete(AuthUser $authUser, CardState $cardState): bool
    {
        return $authUser->can('ForceDelete:CardState');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:CardState');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:CardState');
    }

    public function replicate(AuthUser $authUser, CardState $cardState): bool
    {
        return $authUser->can('Replicate:CardState');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:CardState');
    }
}
